/* boot-anim-running: Check if the animation is active
 * copyright 2009 One Laptop per Child
 * Released under the GPLv2+, see COPYING for details
 */
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>

#include "utils.h"

int
main (int argc, char *argv[])
{
  int fb_file = 0;
  unsigned short *fb = NULL;
  unsigned int *state;
  int r = 0;

  /* update animation frame here, if we meet the requirements. */
  fb_file = open ("/dev/fb0", O_RDWR);
  if (fb_file < 0)
  {
    write (1, "Couldn't open /dev/fb0 for boot animation.\n", 44);
    return 1;
  }

  fb = (unsigned short *)mmap (NULL,
                               FB_SIZE_B + EXTRA_SPACE,
                               PROT_READ|PROT_WRITE,
                               MAP_SHARED,
                               fb_file,
                               0);

  state = (unsigned int *)&fb[FB_SIZE];

  if (!boot_anim_started (state) || !state[RUNNING])
    r = 1;

  munmap (fb, FB_SIZE_B);
  close (fb_file);

  return r;
}

