/* boot-anim-stop
 * copyright 2009 Bobby Powers, released under the GPLv2+
 * see COPYING for details
 *
 * cleans up from graphical boot
 */
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <linux/kd.h>
#include <linux/vt.h>
#include <string.h>

#include "utils.h"

int
main (int argc, char *argv[])
{
  int fd;

  /* much of this is duplicated from the cleanup sequences in boot-anim-helper,
   * we do it again here in case boot-anim-helper had crashed. */

  /* turn off RUNNING flag in order to stop further drawing */
  fd = open ("/dev/fb0", O_RDWR);
  if (fd >= 0)
  {
    unsigned short *fb = (unsigned short *)mmap (NULL,
                               FB_SIZE_B + EXTRA_SPACE,
                               PROT_READ|PROT_WRITE,
                               MAP_SHARED,
                               fd,
                               0);
    unsigned int *state = (unsigned int *)&fb[FB_SIZE];
    if (boot_anim_started (state))
      state[RUNNING] = 0;
    close (fd);
  }

  /* change to vt1 */
  fd = open ("/dev/console", O_RDWR);
  if (fd >= 0)
  {
    /* disable console redirection */
    ioctl (fd, TIOCCONS);
    chvt_in_userspace (fd, 1);
	close (fd);
  }

  fd = open ("/dev/tty2", O_WRONLY);
  if (fd >= 0) {
    struct vt_mode newmode;
    /* back to VT_AUTO and text mode */
    ioctl (fd, KDSETMODE, KD_TEXT);
    memset (&newmode, 0, sizeof (newmode));
    ioctl (fd, VT_SETMODE, &newmode);
    close (fd);
  }

  return 0;
}

